shithub: opus

Download patch

ref: a0cbeca880a4592246bbd21247a35a98345cdafe
parent: 7f0fbd92ac000744a4161bcea473e33271ec9dee
author: Jean-Marc Valin <[email protected]>
date: Thu Jul 8 07:27:20 EDT 2010

autotools-based build system

--- a/Makefile
+++ /dev/null
@@ -1,9 +1,0 @@
-all: celt silk
-	(cd src; make)
-
-celt:
-	(cd celt; make)
-
-silk:
-	(cd silk; make)
-
--- /dev/null
+++ b/Makefile.am
@@ -1,0 +1,8 @@
+## Process this file with automake to produce Makefile.in. -*-Makefile-*-
+
+# To disable automatic dependency tracking if using other tools than
+# gcc and gmake, add the option 'no-dependencies'
+AUTOMAKE_OPTIONS = 1.6
+
+#Fools KDevelop into including all files
+SUBDIRS = celt silk src
--- /dev/null
+++ b/autogen.sh
@@ -1,0 +1,111 @@
+#!/bin/sh
+# Run this to set up the build system: configure, makefiles, etc.
+# (based on the version in enlightenment's cvs)
+
+package="ietfcodec"
+
+olddir=`pwd`
+srcdir=`dirname $0`
+test -z "$srcdir" && srcdir=.
+
+cd "$srcdir"
+DIE=0
+
+echo "checking for autoconf... "
+(autoconf --version) < /dev/null > /dev/null 2>&1 || {
+        echo
+        echo "You must have autoconf installed to compile $package."
+        echo "Download the appropriate package for your distribution,"
+        echo "or get the source tarball at ftp://ftp.gnu.org/pub/gnu/"
+        DIE=1
+}
+
+VERSIONGREP="sed -e s/.*[^0-9\.]\([0-9]\.[0-9]*\).*/\1/"
+VERSIONMKINT="sed -e s/[^0-9]//"
+                                                                                
+# do we need automake?
+if test -r Makefile.am; then
+  AM_NEEDED=`fgrep AUTOMAKE_OPTIONS Makefile.am | $VERSIONGREP`
+  if test -z $AM_NEEDED; then
+    echo -n "checking for automake... "
+    AUTOMAKE=automake
+    ACLOCAL=aclocal
+    if ($AUTOMAKE --version < /dev/null > /dev/null 2>&1); then
+      echo "yes"
+    else
+      echo "no"
+      AUTOMAKE=
+    fi
+  else
+    echo -n "checking for automake $AM_NEEDED or later... "
+    for am in automake-$AM_NEEDED automake$AM_NEEDED automake; do
+      ($am --version < /dev/null > /dev/null 2>&1) || continue
+      ver=`$am --version < /dev/null | head -n 1 | $VERSIONGREP | $VERSIONMKINT`
+      verneeded=`echo $AM_NEEDED | $VERSIONMKINT`
+      if test $ver -ge $verneeded; then
+        AUTOMAKE=$am
+        echo $AUTOMAKE
+        break
+      fi
+    done
+    test -z $AUTOMAKE &&  echo "no"
+    echo -n "checking for aclocal $AM_NEEDED or later... "
+    for ac in aclocal-$AM_NEEDED aclocal$AM_NEEDED aclocal; do
+      ($ac --version < /dev/null > /dev/null 2>&1) || continue
+      ver=`$ac --version < /dev/null | head -n 1 | $VERSIONGREP | $VERSIONMKINT`
+      verneeded=`echo $AM_NEEDED | $VERSIONMKINT`
+      if test $ver -ge $verneeded; then
+        ACLOCAL=$ac
+        echo $ACLOCAL
+        break
+      fi
+    done
+    test -z $ACLOCAL && echo "no"
+  fi
+  test -z $AUTOMAKE || test -z $ACLOCAL && {
+        echo
+        echo "You must have automake installed to compile $package."
+        echo "Download the appropriate package for your distribution,"
+        echo "or get the source tarball at ftp://ftp.gnu.org/pub/gnu/"
+        exit 1
+  }
+fi
+
+echo -n "checking for libtool... "
+for LIBTOOLIZE in libtoolize glibtoolize nope; do
+  ($LIBTOOLIZE --version) < /dev/null > /dev/null 2>&1 && break
+done
+if test x$LIBTOOLIZE = xnope; then
+  echo "nope."
+  LIBTOOLIZE=libtoolize
+else
+  echo $LIBTOOLIZE
+fi
+($LIBTOOLIZE --version) < /dev/null > /dev/null 2>&1 || {
+	echo
+	echo "You must have libtool installed to compile $package."
+	echo "Download the appropriate package for your system,"
+	echo "or get the source from one of the GNU ftp sites"
+	echo "listed in http://www.gnu.org/order/ftp.html"
+	DIE=1
+}
+
+if test "$DIE" -eq 1; then
+        exit 1
+fi
+
+echo "Generating configuration files for $package, please wait...."
+
+echo "  $ACLOCAL $ACLOCAL_FLAGS"
+$ACLOCAL $ACLOCAL_FLAGS || exit 1
+#echo "  autoheader"
+#autoheader || exit 1
+echo "  $LIBTOOLIZE --automake"
+$LIBTOOLIZE --automake || exit 1
+echo "  $AUTOMAKE --add-missing $AUTOMAKE_FLAGS"
+$AUTOMAKE --add-missing $AUTOMAKE_FLAGS || exit 1
+echo "  autoconf"
+autoconf || exit 1
+
+cd $olddir
+#$srcdir/configure "$@" && echo
--- /dev/null
+++ b/configure.ac
@@ -1,0 +1,29 @@
+#                                               -*- Autoconf -*-
+# Process this file with autoconf to produce a configure script.
+
+AC_PREREQ([2.59])
+AC_INIT(src/hybrid.h)
+AM_INIT_AUTOMAKE(libietfcodec,0.0.0)
+
+# Checks for programs.
+AC_PROG_CC
+AC_PROG_LIBTOOL
+
+# Checks for header files.
+AC_HEADER_STDC
+AC_CHECK_HEADERS([float.h stdint.h stdlib.h string.h])
+
+# Checks for typedefs, structures, and compiler characteristics.
+AC_C_CONST
+AC_C_INLINE
+AC_C_RESTRICT
+AC_TYPE_SIZE_T
+
+# Checks for library functions.
+AC_FUNC_MALLOC
+
+AC_CONFIG_SUBDIRS([celt])
+AC_CONFIG_SUBDIRS([silk])
+
+AC_CONFIG_FILES([Makefile src/Makefile])
+AC_OUTPUT
--- a/src/Makefile
+++ /dev/null
@@ -1,2 +1,0 @@
-all:
-	gcc -DHAVE_CONFIG_H -I../celt -W -Wextra -Wall -O3 -g -I../ -I../celt/libcelt -L../celt/libcelt/.libs/ -o test_hybrid test_hybrid.c hybrid_decoder.c hybrid_encoder.c ../silk/test/SKP_debug.o ../silk/libSKP_SILK_SDK.a -lcelt0 -I../silk/interface -lm
--- /dev/null
+++ b/src/Makefile.am
@@ -1,0 +1,13 @@
+
+INCLUDES = -I$(top_srcdir)/celt/libcelt/ -I$(top_srcdir)/silk/interface 
+
+lib_LTLIBRARIES = libietfcodec.la
+libietfcodec_la_SOURCES = hybrid_decoder.c hybrid_encoder.c
+
+noinst_HEADERS = hybrid_decoder.h hybrid_encoder.h
+
+pkginclude_HEADERS = hybrid.h
+
+noinst_PROGRAMS = test_hybrid
+test_hybrid_SOURCES = test_hybrid.c $(top_srcdir)/silk/test/SKP_debug.c
+test_hybrid_LDADD = libietfcodec.la $(top_builddir)/celt/libcelt/libcelt0.la $(top_builddir)/silk/libSKP_SILK_SDK.la
--- a/src/hybrid_decoder.c
+++ b/src/hybrid_decoder.c
@@ -37,8 +37,8 @@
 #include <stdio.h>
 #include <stdarg.h>
 #include "hybrid_decoder.h"
-#include "celt/libcelt/entdec.h"
-#include "celt/libcelt/modes.h"
+#include "entdec.h"
+#include "modes.h"
 #include "SKP_Silk_SDK_API.h"
 
 
--- a/src/hybrid_decoder.h
+++ b/src/hybrid_decoder.h
@@ -32,7 +32,7 @@
 #ifndef HYBRID_DECODER_H
 #define HYBRID_DECODER_H
 
-#include "celt/libcelt/celt.h"
+#include "celt.h"
 #include "hybrid.h"
 
 struct HybridDecoder {
--- a/src/hybrid_encoder.c
+++ b/src/hybrid_encoder.c
@@ -37,8 +37,8 @@
 #include <stdio.h>
 #include <stdarg.h>
 #include "hybrid_encoder.h"
-#include "celt/libcelt/entenc.h"
-#include "celt/libcelt/modes.h"
+#include "entenc.h"
+#include "modes.h"
 #include "SKP_Silk_SDK_API.h"
 
 HybridEncoder *hybrid_encoder_create()
--- a/src/hybrid_encoder.h
+++ b/src/hybrid_encoder.h
@@ -32,7 +32,7 @@
 #ifndef HYBRID_ENCODER_H
 #define HYBRID_ENCODER_H
 
-#include "celt/libcelt/celt.h"
+#include "celt.h"
 #include "hybrid.h"
 #include "SKP_Silk_SDK_API.h"